%global srcname pycurl
%global libcurl_ver %(sed '/^#define LIBCURL_VERSION "/!d;s/"[^"]*$//;s/.*"//;q'} /usr/include/curl/curlver.h 2>/dev/null || echo 0)

Summary:        A Python interface to libcurl
Name:           python-%{srcname}
Version:        7.45.2
Release:        4%{?dist}
License:        LGPLv2+ or MIT
URL:            http://pycurl.io/
Source0:        %{pypi_source}

Patch3001:      0001-python-pycurl-7.45.1-tls-backend.patch
Patch3002:      0002-python-pycurl-7.45.2-disable-test_http_version_3.patch

BuildRequires:  gcc make vsftpd libcurl-devel openssl-devel

%description
PycURL is a Python interface to libcurl, the multiprotocol file transfer library. 
Similarly to the urllib Python module, PycURL can be used to fetch objects identified 
by a URL from a Python program. 

%package -n python3-%{srcname}
Summary:        Python interface to libcurl for Python 3
BuildRequires:  python3-devel python3-setuptools
Requires:       libcurl >= %{libcurl_ver}

%description -n python3-%{srcname}
PycURL is a Python interface to libcurl, the multiprotocol file transfer library. 
Similarly to the urllib Python module, PycURL can be used to fetch objects identified 
by a URL from a Python program. 

%prep
%autosetup -n %{srcname}-%{version} -p1

rm -fv winbuild.py
sed -e 's|python |%{python3} |' -i tests/ext/test-suite.sh
sed -e 's|^#! */usr/bin/env python$|#! /usr/bin/env %{python3}|' \
    -i tests/*.py setup.py

%build
%py3_build -- --with-openssl

%install
export PYCURL_SSL_LIBRARY=openssl
%py3_install
rm -rf %{buildroot}%{_datadir}/doc/pycurl

%check
# relax crypto policy for the test-suite to make it pass again
# https://bugzilla.redhat.com/show_bug.cgi?id=1863711
export OPENSSL_SYSTEM_CIPHERS_OVERRIDE=XXX
export OPENSSL_CONF=

export PYTHONPATH=%{buildroot}%{python3_sitearch}
export PYCURL_SSL_LIBRARY=openssl
export PYCURL_VSFTPD_PATH=vsftpd
export PYTEST_ADDOPTS="--ignore examples -m 'not online'"
make test PYTHON=%{__python3} PYTEST=true PYFLAKES=true
rm -fv tests/fake-curl/libcurl/*.so
rm -fvr tests/__pycache__

%files -n python3-%{srcname}
%license COPYING-LGPL COPYING-MIT
%doc ChangeLog README.rst examples doc tests
%{python3_sitearch}/curl/
%{python3_sitearch}/%{srcname}.*.so
%{python3_sitearch}/%{srcname}-%{version}-*.egg-info

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.45.2-4
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.45.2-3
- Rebuilt for loongarch release

* Thu Oct 12 2023 Miaojun Dong <zoedong@tencent.com> - 7.45.2-2
- Rebuild for curl-8.4.0

* Mon Sep 25 2023 Shuo Wang <abushwang@tencent.com> - 7.45.2-1
- update to 7.45.2

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.45.1-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.45.1-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.45.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 7.45.1-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Sep 30 2022 Cheng Xin <denisecheng@tencent.com> - 7.45.1-1
- package init.
